
import
  preserves

type
  TimerExpired* {.preservesRecord: "timer-expired".} = object
    `label`*: Value
    `seconds`*: float64

  SetTimer* {.preservesRecord: "set-timer".} = object
    `label`*: Value
    `seconds`*: float64
    `kind`*: TimerKind

  `TimerKind`* {.preservesOr, pure.} = enum
    `relative`, `absolute`, `clear`
  LaterThan* {.preservesRecord: "later-than".} = object
    `seconds`*: float64

proc `$`*(x: TimerExpired | SetTimer | LaterThan): string =
  `$`(toPreserves(x))

proc encode*(x: TimerExpired | SetTimer | LaterThan): seq[byte] =
  encode(toPreserves(x))
